//sound_effector.c

/**
 * @file  sound_effector.c
 * @brief TEhGtFNg
 *
 * @version: $Id $
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copych1 (C) Hokuto denshi Co,Ltd. 2019
 */
 
#include <machine.h>
#include "sound_effector.h"
#include "Config_CMT0.h"
#include "Config_TPU1.h"
#include "Config_RSPI0.h"
#include "Config_DMAC0.h"


//AhXti384kB̊gRAM̈j
#pragma address g_inbuf=BUF_RAM_START_ADDR
 
//O[oϐ

//Mobt@(FIFO)
pcm_data g_outbuf[OUTBUF_SIZE];

//Mobt@
pcm_data g_inbuf[INBUF_SIZE];

unsigned long g_outbuf_rp;			//Mobt@ReadPointerϐ
unsigned long g_outbuf_wp;			//Mobt@WritePointerϐ

unsigned long g_inbuf_wp;			//Mobt@WritePointerϐ

//Mf[^
short g_rspi0_send_data;

#if (OUT_CH == 2)
pcm_data g_next_send_data;
pcm_data g_zero_data;
#elif (OUT_CH == 1)
short g_next_send_data;
short g_zero_data;
#endif

//RSPIʐMtO
unsigned short g_rspi0_flag;

//TvO(20.83us(=1/48kHz))ŃNAtO
unsigned short g_sampling_period_flag;

//TvO(20.83us(=1/48kHz))ŃCNgϐ
unsigned long g_sampling_counter;

//XCb`̓ǂݎ
unsigned char g_sw_state;			//PE0

//A/DϊtOA/Dϊ
unsigned short g_ad_flag;
unsigned short g_ad_val[3];			//AN001-002

#ifdef DEBUG

//RSPI 0f[^M񐔁io̓obt@j
unsigned long g_rspi_null_data_count;

//Write/ErrLED
unsigned long g_err_led_patturn;
unsigned long g_err_led_index;

#endif

#ifdef DEBUG2

//RSPIMJE^
unsigned long g_rspi0_success_count;

//RSPIMsJE^
unsigned long g_rspi0_error_count;

#endif

//֐`

void sound_effector_init(void)
{
	//֐
	
	//FȂ
	
	//߂lFȂ
	
	unsigned long i;
	
	//ϐ
	
#if (OUT_CH == 2)
	for(i=0; i<OUTBUF_SIZE; i++)
	{
		g_outbuf[i].ch0 = 0;
		g_outbuf[i].ch1 = 0;
	}
#elif (OUT_CH == 1)
	for(i=0; i<OUTBUF_SIZE; i++)
	{
		g_outbuf[i] = 0;
	}
#endif
	
	for(i=0; i<INBUF_SIZE; i++)
	{
		g_inbuf[i].ch0 = 0;
		g_inbuf[i].ch1 = 0;
	}
	
	g_outbuf_rp = 0;
	g_outbuf_wp = 0;

	g_inbuf_wp = 0;
	
	g_rspi0_send_data = 0;
	
#if (OUT_CH == 2)
	g_next_send_data.ch0 = 0;
	g_next_send_data.ch1 = 0;
	g_zero_data.ch0 = 0;
	g_zero_data.ch1 = 0;
#elif (OUT_CH == 1)
	g_next_send_data =0 ;
	g_zero_data = 0;
#endif
	
	g_rspi0_flag = 0;
	
	g_sampling_period_flag = 0;
	g_sampling_counter = 0;
	
	g_sw_state = 0;
	
	g_ad_flag=0;
	
	for(i=0; i<3; i++) g_ad_val[i]=0;

#ifdef DEBUG

	g_rspi_null_data_count = 0;
	
	g_err_led_patturn = 0x00000000;
	g_err_led_index = 0x00000001;
	
	//PC0(ErrLED)
	PORTC.PDR.BIT.B0 = 1;
	PORTC.PODR.BIT.B0 = 0;

#endif

#ifdef DEBUG2

	g_rspi0_success_count = 0;	
	g_rspi0_error_count = 0;

#endif

#ifdef DEBUG_PORT

	//P27
	PORT2.PODR.BIT.B7 = 0;
	PORT2.PDR.BIT.B7 = 1;

	//P26
	PORT2.PODR.BIT.B6 = 0;
	PORT2.PDR.BIT.B6 = 1;
	
	//P30
	PORT3.PODR.BIT.B0 = 0;
	PORT3.PDR.BIT.B0 = 1;
	
#endif
	
	//PE0, pull-upݒ
	PORTE.PDR.BYTE &= ~0x01;	//PE0:input
	PORTE.PCR.BYTE |= 0x01;		//PE0:pull-up
}

void sound_effector_start(void)
{
	//Jn֐
	
	//FȂ
	
	//߂lFȂ
	
	//BLCK=12.288MHzo
	SYSTEM.PRCR.WORD = 0xA503;
	
	SYSTEM.SCKCR.BIT.PSTOP1 = 1;
	while(SYSTEM.SCKCR.BIT.PSTOP1 != 1) nop();
	
	//BLCKo
	MPC.PFBCR0.BIT.BCLKO = 1;
	
	SYSTEM.SCKCR.BIT.PSTOP1 = 0;
	while(SYSTEM.SCKCR.BIT.PSTOP1 != 0) nop();
	
	SYSTEM.PRCR.WORD = 0xA500;
	
	g_sw_state = PORTE.PIDR.BYTE & 0x1;		//PE0 lǂݏo,ݒ
	
	R_Config_RSPI0_Start();		//f[^ʐM(RSPI0)

	R_Config_TPU1_Start();		//48kHz
	
	R_Config_CMT0_Start();		//50ms1iXCb`ǂݎA/Dϊj
	
	DMAC0.DMCRA = INBUF_UNIT_SIZE*2;	//DMAC:1ɏf[^
	
	R_Config_DMAC0_Start();		//DMAC
}

#if (OUT_CH == 2)
int put_data( pcm_data data )
{
	//pcmf[^(2ch)o̓obt@Ɋi[֐
	
	//F
	//  pcm_data data : ch0, ch1̃f[^ishort^j
	
	//߂lF
	//  0 : I
	//  1 : o̓obt@t
	
	unsigned long outbuf_next_wp;
	
	outbuf_next_wp = g_outbuf_wp + 1;
	
	if(outbuf_next_wp >= OUTBUF_SIZE) outbuf_next_wp = 0;
	
	if(outbuf_next_wp == g_outbuf_rp)
	{
		return 1;	//obt@t, f[^̊i[͍sȂ
	}
	
	g_outbuf[g_outbuf_wp] = data;
	
	g_outbuf_wp = outbuf_next_wp;
	
	return 0;
}
#endif

#if (OUT_CH == 1)
int put_data( short data )
{
	//pcmf[^(1ch)o̓obt@Ɋi[֐
	
	//F
	//  pcm_data data : ch0, ch1̃f[^ishort^j
	
	//߂lF
	//  0 : I
	//  1 : o̓obt@t
	
	unsigned long outbuf_next_wp;
	
	outbuf_next_wp = g_outbuf_wp + 1;
	
	if(outbuf_next_wp >= OUTBUF_SIZE) outbuf_next_wp = 0;
	
	if(outbuf_next_wp == g_outbuf_rp)
	{
		return 1;	//obt@t, f[^̊i[͍sȂ
	}
	
	g_outbuf[g_outbuf_wp] = data;
	
	g_outbuf_wp = outbuf_next_wp;
	
	return 0;
}
#endif

#if (OUT_CH == 2)
pcm_data clipping_data_norm(float ch0_data, float ch1_data)
{
	//NbsO, short^ւ̕ϊs֐
	//i̓f[^1ɐKꂽf[^j
	
	//F
	//  float ch0_data  : ch0̃f[^
	//  float ch1_data  : ch1̃f[^
	
	//߂lF
	//  pcmf[^ishort^̍\́j
	
	pcm_data ret;
	
	if(ch0_data > CLIPPING_NORM_MAX) ch0_data = CLIPPING_NORM_MAX;
	else if(ch0_data < CLIPPING_NORM_MIN) ch0_data = CLIPPING_NORM_MIN;
					
	if(ch1_data > CLIPPING_NORM_MAX) ch1_data = CLIPPING_NORM_MAX;
	else if(ch1_data < CLIPPING_NORM_MIN) ch1_data = CLIPPING_NORM_MIN;
					
	ret.ch0 = (short)(ch0_data * 32768.0);
	ret.ch1 = (short)(ch1_data * 32768.0);
	
	return ret;
}
#endif

#if (OUT_CH == 2)
pcm_data clipping_data_raw(float ch0_data, float ch1_data)
{
	//NbsO, short^ւ̕ϊs֐
	//i̓f[^͐f[^-32768`32768float^j
	
	//F
	//  float ch0_data  : ch0̃f[^
	//  float ch1_data  : ch1̃f[^
	
	//߂lF
	//  pcmf[^ishort^̍\́j
	
	pcm_data ret;
	long tmp;
	
	tmp = (long)ch0_data;
	
	if(tmp > CLIPPING_RAW_MAX) tmp = CLIPPING_RAW_MAX;
	else if(tmp < CLIPPING_RAW_MIN) tmp = CLIPPING_RAW_MIN;
					
	ret.ch0 = (short)tmp;
	
	tmp = (long)ch1_data;
	
	if(tmp > CLIPPING_RAW_MAX) tmp = CLIPPING_RAW_MAX;
	else if(tmp < CLIPPING_RAW_MIN) tmp = CLIPPING_RAW_MIN;
	
	ret.ch1 = (short)tmp;
	
	return ret;
}
#endif

#if (OUT_CH == 1)
short clipping_data_norm(float data)
{
	//NbsO, short^ւ̕ϊs֐
	//i̓f[^1ɐKꂽf[^j
	
	//F
	//  float data  : f[^
	
	//߂lF
	//  short FNbsÕf[^
	
	if(data > CLIPPING_NORM_MAX) data = CLIPPING_NORM_MAX;
	else if(data < CLIPPING_NORM_MIN) data = CLIPPING_NORM_MIN;
					
	return((short)(data * 32768.0));
}
#endif

#if (OUT_CH == 1)
short clipping_data_raw(float data)
{
	//NbsO, short^ւ̕ϊs֐
	//i̓f[^͐f[^-32768`32768float^j
	
	//F
	//  float ch0_data  : ch0̃f[^
	
	//߂lF
	//  short FNbsÕf[^
	
	long tmp;
	
	tmp = (long)data;
	
	if(tmp > CLIPPING_RAW_MAX) tmp = CLIPPING_RAW_MAX;
	else if(tmp < CLIPPING_RAW_MIN) tmp = CLIPPING_RAW_MIN;
					
	return (short)tmp;
}
#endif

unsigned long outbuf_spool_data_num(void)
{
	if(g_outbuf_wp > g_outbuf_rp)
	{
		return g_outbuf_wp - g_outbuf_rp;
	}
	else if(g_outbuf_rp > g_outbuf_wp)
	{
		return OUTBUF_SIZE + g_outbuf_wp - g_outbuf_rp;
	}
	else
	{
		//g_outbuf_wp == g_outbuf_rp, obt@
		return 0;
	}
}

 